function minmuttau = findminMutInf(miV,nsam)
% minmuttau = findminMutInf(miV,nsam)
% findminMutInf finds the lag tau of the first local minimum of mutual 
% information 'miV' (given from lag 0 and up to a maximum lag 'taumax') 
% and using a sliding window of length 2*nsam+1.

taumax = length(miV)-1;
minmuttau = NaN;
if taumax>2*nsam
    i=nsam+1;
    found = 0;
    while i<taumax+1-nsam & found==0
        winx = miV([i-nsam:i-1 i+1:i+nsam]);
        check = find(miV(i) < winx);
        if length(check) == length(winx) 
            found=1;
        else
            i=i+1;
        end
    end
    if found
        minmuttau = i-1;
    end
end
