clear all
ndata = 5;
nmea = 3;
randn('state',0);
meaM = randn(ndata,nmea);
buttonsize = [150 120];

h = figure(1);
clf
axes('position',[0.12 0.16 0.80 0.65])
h1 = plot(meaM(:,1),'o-','Markersize',10,'linewidth',3);
hold on
plot(meaM(:,2),'x--k','Markersize',10,'linewidth',3)
plot(meaM(:,3),'+-.r','Markersize',10,'linewidth',3)
set(gca,'XTickLabelMode','Manual');
set(gca,'XTickLabel',num2str([1:ndata]'));
set(gca,'XTickMode','Manual');
set(gca,'XTick',[1:ndata]');
set(gca,'YTickLabelMode','Manual');
set(gca,'YTickLabel','');
set(gca,'YTickMode','Manual');
set(gca,'YTick',[]);
leg = legend('measure 1','measure 2','measure 3','location','NorthEastOutside');
set(leg,'EdgeColor',[1 1 1])
set(leg,'FontSize',24)
legpos = get(leg,'Position');
ax = axis;
dyax = 0.1*(ax(4)-ax(3));
text(5.2,ax(3)+4*dyax,'1: time series 1','fontsize',24)
text(5.2,ax(3)+3*dyax,'2: time series 2','fontsize',24)
text(5.2,ax(3)+2*dyax,'3: time series 3','fontsize',24)
text(5.2,ax(3)+dyax,'4: time series 4','fontsize',24)
text(5.2,ax(3),'5: time series 5','fontsize',24)
xlabel('time series index','fontsize',50)
ylabel('measure','fontsize',50)
title('free plot','fontsize',80)
% print -r300 -djpeg90 buttonfreeplot.jpg
print -r300 -dbmp buttonfreeplot.bmp
