function kacV=kendallcor(xV,tauV)
% kacV=kendallcor(xV,tauV)
% kendallcor computes the Kendall autocorrelation on the time series 'xV' 
% for given delays in 'tauV'. 

n = length(xV);
ntau = length(tauV);
kacV = NaN*ones(ntau,1);
for itau=1:ntau
    tau = tauV(itau);
    x1V = xV(1:n-tau);
    x2V = xV(tau+1:n);
    n1=length(x1V);
    Q = 0;
    for i=1:n1-1
        for j=i+1:n1
            tmpS = (x2V(j)-x2V(i))*(x1V(j)-x1V(i));
            Q = Q + sign(tmpS);
        end
    end
    kacV(itau) = 2*Q/(n1*(n1-1)); 
end
