function xpreV = lppreonedirT(xV,TreeRoot,winnowV,m,tau,nnei,q,T,mindist,tarintree)
% xpreV = lppreonedirT(xV,TreeRoot,winnowV,m,tau,nnei,q,T,mindist,tarintree)
% Help function called in localARpredir.m and localARfitdir.m

f = 1.2;  % factor to increase the distance if not enough neighbors are found 
tarV = winnowV((m-1)*tau+1:-tau:1)';
distnow = mindist;
if tarintree
    [neiM,neidisV,neiindV]=kdrangequery(TreeRoot,tarV,distnow);
    while length(neiindV)<nnei+1
        distnow = f*distnow;
        [neiM,neidisV,neiindV]=kdrangequery(TreeRoot,tarV,distnow);
    end
    [oneidisV,oneiindV]=sort(neidisV);
    neiindV = neiindV(oneiindV(2:nnei+1));
    neidisV = neidisV(oneiindV(2:nnei+1));
    neiM = neiM(oneiindV(2:nnei+1),:);
    xpreM = NaN*ones(nnei,T);
    for inei=1:nnei
        xpreM(inei,:)=xV(neiindV(inei)+(m-1)*tau+1:neiindV(inei)+(m-1)*tau+T);
    end
    if nnei==1
        xpreV = xpreM';
    elseif q==0
        xpreV = (mean(xpreM))';
    else
        mneiV = mean(neiM);
        myV = mean(xpreM);
        zM = neiM - ones(nnei,1)*mneiV;
        [Ux, Sx, Vx] = svd(zM, 0);
        tmpM = Vx(:,1:q) * inv(Sx(1:q,1:q)) * Ux(:,1:q)';
        for j=1:T
            lsbV = tmpM * (xpreM(:,j) - myV(j));
            xpreV(j) = myV(j) + (tarV-mneiV) * lsbV;
        end
    end
elseif nnei==1
    [neiind,neidis,TreeRoot]=kdtreeidx([],tarV,TreeRoot);
    xpreV = xV(neiind+(m-1)*tau+1:neiind+(m-1)*tau+T);
else
    [neiM,neidisV,neiindV]=kdrangequery(TreeRoot,tarV,distnow);
    while length(neiindV)<nnei
        distnow = f*distnow;
        [neiM,neidisV,neiindV]=kdrangequery(TreeRoot,tarV,distnow);
    end
    [oneidisV,oneiindV]=sort(neidisV);
    neiindV = neiindV(oneiindV(1:nnei));
    neidisV = neidisV(oneiindV(1:nnei));
    neiM = neiM(oneiindV(1:nnei),:);
    xpreM = NaN*ones(nnei,T);
    for inei=1:nnei
        xpreM(inei,:)=xV(neiindV(inei)+(m-1)*tau+1:neiindV(inei)+(m-1)*tau+T);
    end
    if q==0 
        xpreV = (mean(xpreM))';
    else
        mneiV = mean(neiM);
        myV = mean(xpreM);
        zM = neiM - ones(nnei,1)*mneiV;
        [Ux, Sx, Vx] = svd(zM, 0);
        tmpM = Vx(:,1:q) * inv(Sx(1:q,1:q)) * Ux(:,1:q)';
        for j=1:T
            lsbV = tmpM * (xpreM(:,j) - myV(j));
            xpreV(j) = myV(j) + (tarV-mneiV) * lsbV;
        end
    end
end