function mutV=mutinfHisDis(yV,tauV,b,imax)
% mutV=mutinfHisDis(yV,tauV,b)
% mutinfHisDis computes the mutual information on the time series 'yV' 
% for given delays in 'tauV'. The estimation of mutual information is 
% based on 'b' partitions of equal distance at each dimension. 
% The last input parameter is the index of the maximum of the time series
% that will be assigned the largest bin index (a technical detail).

n = length(yV);
ntau = length(tauV);
mutV = NaN*ones(ntau,1);
h1V = zeros(b,1);  % for p(x(t+tau))
h2V = zeros(b,1);  % for p(x(t))
h12M = zeros(b,b);  % for p(x(t+tau),x(t))
arrayV = floor(yV*b)+1; % Array of b: 1,...,b
arrayV(imax) = b; % Set the maximum in the last partition
for itau=1:ntau
    tau = tauV(itau);
    ntotal = n-tau;
    mutS = 0;
    for i=1:b
        for j=1:b
            h12M(i,j) = length(find(arrayV(tau+1:n)==i & arrayV(1:n-tau)==j));
        end
    end
    for i=1:b
        h1V(i) = sum(h12M(i,:));
        h2V(i) = sum(h12M(:,i));
    end
    for i=1:b
        for j=1:b
            if h12M(i,j) > 0
                mutS=mutS+(h12M(i,j)/ntotal)*log(h12M(i,j)*ntotal/(h1V(i)*h2V(j)));
            end
        end
    end
    mutV(itau) = mutS;
end
