function txtout = replacesymbol(txtin,symbolfind,symbolreplace)
% txtout = replacesymbol(txtin,symbolinfind,symbolreplace)
% REPLACESYMBOL replaces all occurences of a given symbol 'symbolfind' with 
% another symbol 'symbolreplace' (can also be blank '') in a given cell array 
% of strings or matrix of strings 'txtin'.
% INPUT 
% - txtin       : the input cell array of strings or matrix of strings.
% - symbolfind  : the symbol to be found
% - symbolreplace : the symbol to replace symbolfind.
% OUTPUT
% - txtout      : same as txtin but with symbolfind replaced by
%                 symbolreplace.
if iscell(txtin)
    [n,m]=size(txtin);
    for i=1:n
        for j=1:m
            if n>1 & m>1
                txtout{i,j}=strrep(txtin{i,j},symbolfind,symbolreplace);
            elseif n==1
                txtout{j}=strrep(txtin{j},symbolfind,symbolreplace);
            elseif m==1
                txtout{i}=strrep(txtin{i},symbolfind,symbolreplace);
            else
                txtout=strrep(txtin,symbolfind,symbolreplace);
            end
        end
    end
elseif ischar(txtin)
    [n,m]=size(txtin);
    txtout=str2mat(strrep(txtin(1,:),symbolfind,symbolreplace));
    if n>1
        for i=2:n
            txtout=str2mat(txtout,strrep(txtin(i,:),symbolfind,symbolreplace));
        end
    end
end
