function sacV=spearmancor(xV,tauV)
% kacV=kendallcor(xV,tauV)
% spearmancor computes the Spearman autocorrelation on the time series 'xV' 
% for given delays in 'tauV'. 

n = length(xV);
ntau = length(tauV);
sacV = NaN*ones(ntau,1);
for itau=1:ntau
    tau = tauV(itau);
    x1V = xV(1:n-tau);
    x2V = xV(tau+1:n);
    n1=length(x1V);
    [oxV,ixV]=sort(x1V);
    [tmpS,jxV]=sort(ixV);
    [oyV,iyV]=sort(x2V);
    [tmpS,jyV]=sort(iyV);
    djxyV = jxV-jyV;
    sacV(itau) = 1-6*sum(djxyV.^2)/(n1*(n1^2-1));
end
